config/routes.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
# SPDX-License-Identifier: AGPL-3.0-or-later

Rails.application.routes.draw do

  get 'sections/show'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root to: 'welcome#index'

  # Agent routes
  resources :agents do
    shallow do
      # Classification routes
      resources :taxonomies do
        member do
          get :filter, to: 'taxonomies/filter#show'
        end
        resources :categories do
          resources :sections
        end
      end
      # Resource routes
      resources :resources
    end
  end

  # User routes
  get '/my/account', to: 'users#show', as: 'account'
  patch '/my/current_agent', to: 'my/agent#switch', as: 'agent_switch'
  get '/my/dashboard', to: 'welcome#dashboard'
  get '/my/peers', to: 'users#index', as: 'users'

  # UUID Resolver
  get '/by-uuid/:uuid', to: 'uuid_resolver#new', as: 'uuid_resolver'

  # Discourse SSO
  get 'authenticate(/:token)', to: 'welcome#authenticate', as: 'authenticate'
  get 'logout', to: 'welcome#logout'
end

app/models/agent.rb
# SPDX-FileCopyrightText: 2020 IN COMMON Collective <collective@incommon.cc>
#
# SPDX-License-Identifier: AGPL-3.0-or-later

class Agent < ApplicationRecord
  has_many :agencies
  has_many :members, through: :agencies, source: :user
  has_many :resources
  has_many :taxonomies
  has_many :categories, through: :taxonomies
  has_many :sections, through: :categories

  def to_param
    uuid
  end

  def to_s
    name
  end

  # Syntactic sugar -- but they're really members.
  def users
    Rails.logger.warn "Calling `Agent#users`! You should be using `Agent#members` instead."
    members
  end
end

app/views/resources/_edit.html.erb
<h3>Edit <%= @resource.presence.name || 'new resource' %></h3>
<h2>Context: <%= current_agent %></h2>

<%= form_with model: @resource, url: @resource.presence.new_record? ? agent_resources_path(current_agent) : resource_path(@resource.resource) do |f| %>
    <%= render partial: 'form', locals: { resource: resource, f: f } %>
<% end %>

app/views/resources/_form.html.erb
<% if resource.errors.any? %>
    <div id="error_explanation">
        <h2><%= pluralize(resource.errors.count, "error") %> prohibited this resource from being saved:</h2>

        <ul>
            <% resource.errors.each do |error| %>
                <li><%= error.full_message %></li>
            <% end %>
        </ul>
    </div>
<% end %>

    <fieldset>
    <%= tag.legend "Propriétés de la ressource" %>

    <dl class="field">
        <dt><%= f.label :name %></dt>
        <dd><%= f.text_field :name, maxlength: 64, placeholder: 'La ferme des animaux' %></dd>

        <dt><%= f.label :summary %></dt>
        <dd><%= f.text_field :summary, maxlength: 136, placeholder: 'Une ferme locale' %></dd>

        <dt><%= f.label :description %></dt>
        <dd><%= f.text_area :description, cols: 72, rows: 10, placeholder: '## Un choix pertinent

La description _peut_ comporter du [Markdown].

[Markdown]: https://www.markdownguide.org/getting-started/' %></dd>

        <dt><%= f.label :email %></dt>
        <dd><%= f.email_field :email, placeholder: 'bonjour@la-ferme-des-animaux.example' %></dd>

        <dt><%= f.label :website %></dt>
        <dd><%= f.url_field :website, placeholder: 'https://la-ferme-des-animaux.example' %></dd>

        <dt><%= f.label :phone_number %></dt>
        <dd><%= f.telephone_field :phone_number, placeholder: '+32 489 000 0000' %></dd>
    </dl>
</fieldset>

<fieldset>
    <%= tag.legend "Classification" %>
    <%# TODO Add a taxonomy selector %>
    <%= section_select(current_agent.taxonomies&.first || Taxonomy.first, resource.section_ids, name: 'resource_form[section_ids]') %>
</fieldset>

<fieldset>
    <%= tag.legend "Coordonées géographiques" %>
    <%# TODO Add a graphical geo selector %>

    <dl class="field">
        <dt><%= f.label :address %></dt>
        <dd><%= f.text_field :address, placeholder: 'Rue aux herbes, 123' %></dd>

        <dt><%= f.label :postal_code %></dt>
        <dd><%= f.text_field :postal_code, placeholder: '1000' %></dd>

        <dt><%= f.label :city %></dt>
        <dd><%= f.text_field :city, placeholder: 'Bruxelles' %></dd>
    </dl>

    <dl class="field">
        <dt><%= f.label :longitude %></dt>
        <dd><%= f.text_field :longitude, placeholder: '0.56789012', pattern: '[\d]+.[\d]+' %></dd>

        <dt><%= f.label :latitude %></dt>
        <dd><%= f.text_field :latitude, placeholder: '50.12345678', pattern: '[\d]+.[\d]+' %></dd>
    </dl>
</fieldset>

<%= f.hidden_field :agent_id, value: current_agent.id %>
<%= f.hidden_field :source, value: current_agent.name %>

<p><%= f.submit 'Save' %></p>

app/views/resources/_popup.html.erb
<article class="resource" id="res-<%= resource.uuid %>">
    <h1><%= resource.name %></h1>
    <p class="summary"><%= h resource.summary %></p>
    <% unless resource.description.blank? %>
    <section class="description">
        <h2>Description</h2>
        <%= m resource.description %>
    </section>
    <% end %>
    <nav>
        <ul>
            <li><%= link_to(tag.nobr(resource.uuid), resource_path(resource), title: 'voir la fiche correspondante') %></li>
            <li><%= link_to('modifier', edit_resource_url(resource), title: 'nodifier cette ressource') %></li>
        </ul>
    </nav>
</article>

app/views/resources/_resource.html.erb
<section id="resource-<%= resource.uuid %>">
    <header>
        <h2><%= resource.properties['name'] %></h2>
        <time datetime="<%= h resource.created_at %>" class="created_at">
            <time datetime="<%= h resource.updated_at %>" class="updated_at">
                <p class="identifier"><%= resource_url(resource) %></p>
    </header>
    <%= m resource.description %>
    <hr>
    <code><pre><%= h JSON.pretty_generate(resource.feature.as_json) %></pre></code>
    <nav>
        <ul>
            <li><%= link_to('show', resource_url(resource)) %></li>
            <% if session[:current_agent] == resource.source %>
                <li><%= link_to 'edit', edit_resource_url(resource) %></li>
                <li><span class="disabled">delete</span></li>
            <% end %></ul>
    </nav>
</section>

app/views/resources/_resource.json.erb
<%= resource.as_json %>

app/views/resources/delete.html.erb
<h1>Resources#delete</h1>
<p>Find me in app/views/resources/delete.html.erb</p>

app/views/resources/edit.html.erb
<%= render partial: 'edit', locals: { resource: @resource, foo: 'foo' } %>

app/views/resources/index.html.erb
<h1>Listing Resources</h1>

<%= paginate @resources %>

<%= render partial: 'resource', collection: @resources %>

app/views/resources/new.html.erb
<%= render 'edit', resource: @resource %>

<#%= render partial: 'edit', locals: { resource: @resource } %>

app/views/resources/show.html.erb
<%= render @resource %>

app/views/resources/show.json.erb
<%= render @resource %>